# JupyterHub

Der JupyterHub stellt eine Python- und R-Umgebung für Sie bereit, damit Sie direkt loslegen können.

## Server starten und stoppen

1. Loggen Sie sich bei https://jupyter.hs-bochum.de mit Ihrer normalen BO-Kennung und Passwort ein.<br>
   ![](images/login-screen.png)

2. Ggf. erhalten Sie eine Auswahl, ansonsten startet der Server direkt für Sie.<br>
   ![](images/server-starting.png)

3. Sie werden zum JupyterLab weitergeleitet. Von dort können Sie VS Code starten um in [Python](#vs-code-für-python) oder [R](#vs-code-für-r) zu entwickeln.<br>
   ![](images/jupyter-lab.png)

4. Wenn Sie fertig sind, stoppen Sie bitte den Server um Ressourcen für andere freizugeben! Dazu klicken Sie im Menü auf *File* → *Hub Control Panel* oder auf https://jupyter.hs-bochum.de/hub/home<br>
   ![](images/menu-file-hub_control_panel.png)

5. Anschließend klicken Sie auf *Stop My Server*! Damit werden evtl. laufende Programme geschlossen und der Zustand des Dateisystems mit der Ausnahme ihrer eigenen Dateien in `/home/jovyan/` wieder zurück gesetzt.<br>
   ![](images/stop-my-server.png)

## VS Code für Python

1. In VS Code (genauer: code-server) können Sie Python-Skripte oder Jupyter-Notebooks über *File* → *New File...* erstellen bzw. per Drag'n'Drop hochladen. Für große Dateien eigenen sich CLI Tools wie `wget` oder `curl` besser. Dateien können mit Rechtsklick → *Download* vom JupyterHub heruntergeladen werden. *Beachten Sie: Dateien in Ihrem Home-Verzeichnis `/home/jovyan/` bleiben bei einem Server-Stop erhalten.<br>
   ![](images/code-upload.png)
2. Zum Entwickeln ist der interaktive Modus komfortabler. Den erreichen Sie neben dem Play-Button mit *Run Current File in Interactive Window* oder einfach, indem Sie Sections `# %%` erstellen und diese z.B. mit `Shift`+`Enter` oder `Ctrl`+`Enter` ausführen.<br>
   ![](images/code-interactive.png)
3. Für sehr lang laufende Skripte ist die Konsole besser. Wenn Sie den Browser-Tab schließen, sollte sich die Konsole wieder verbinden und Sie können die Ausgaben des Skriptes sehen oder es mit `Ctrl`+`C` abbrechen.<br>
   ![](images/code-terminal.png)

*Beachten Sie: Wenn Sie vier Tage nicht über den Browser mit VS Code interagiert haben, wird der Server automatisch gestoppt.*

## Pakete nachinstallieren

Pakete lassen sich einfach mit `mamba install PAKET` oder `pip install PAKET` nach `/opt/conda` nachinstallieren. Bei einem Server-Stop sind sie allerdings wieder weg. Daher macht es vielleicht Sinn die Installation ins Skript mit einem `!` davor hinzuzufügen.

![](images/code-install-hvplot.png)

## Interaktive Plots

Wenn Sie mit JavaScript-basierten Paketen wie Plotly Express oder Bokeh plotten, sind die Plots im interaktiven Fenster automatisch interaktiv.

Damit Matplotlib-Plots interaktiv sind, führen Sie vor dem Plotten `%matplotlib widget` einmalig aus.

![](images/code-mpl-widget.png)

## VS Code für R

1. Erstellen Sie eine neue Textdatei und speichern Sie sie mit der Endung `.r`.
2. Erstellen Sie Sections `# %%` mit Code.
3. Führen Sie die Sections mit `Shift`+`Enter` oder `Ctrl`+`Enter` aus. Plots öffnen sich automatisch und Ausgaben werden im Terminal gezeigt.

![](images/code-r.png)
